const expressions = require("./expressions");

function getStyleTagsContent(html) {
    const styleTags = html.match(expressions.styleTags)
    return styleTags.map(
        tag => tag
            .replace(expressions.styleOpenTags, '')
            .replace(expressions.styleCloseTags, '')
    ).join('\n')
}

function getScriptTagsContent(html) {
    const scriptTags = html.match(expressions.scriptTags)

    const result = scriptTags.map(tag => {
        tag = tag
            .replace(expressions.scriptOpenTags, '')
            .replace(expressions.scriptCloseTags, '')
            .split('\n')
            .slice(1, -1)
            .join('\n')
        const spacesCount = `${tag.match(expressions.newLineWhiteSpaces)}`.length - 1
        return tag
            .replace(new RegExp(`^${' '.repeat(spacesCount)}`, 'gm'), '')
    })
    return result.join('\n\n')
}

module.exports = {
    getStyleTagsContent,
    getScriptTagsContent
}