/*
* Накостылял
* */

const expressions = require('./expressions.js')
const {clearOldFromTrash} = require("./cleaners");
const {getStyleTagsContent, getScriptTagsContent} = require("./content_scrapers");
const {generateClassesForSimilarStyles, generateCSS, generateJS} = require("./generators");
const {generateVirtualCSS} = require("./virtual");

function optimiseStyles(html, styleContent, additionalClasses) {
    const css = generateCSS(generateVirtualCSS(styleContent, additionalClasses))
    return html.replace(expressions.headEnd, `  <style>\n${css}    </style>\n  </head>`)
}

function optimiseScripts(html, scriptContent) {
    const js = generateJS(scriptContent)
    return html.replace(expressions.bodyEnd, `  <script>\n${js}\n    </script>\n  </body>`)
}

module.exports = function optimisePage(html) {
    const styleContent = getStyleTagsContent(html)
    const scriptContent = getScriptTagsContent(html)
    let {newHtml, additionalClasses} = generateClassesForSimilarStyles(clearOldFromTrash(
        html
    ))
    /*
    * Тут находится чистилище каллбэков,
    * эти каллбэки хоть и должны отправиться в свой каллбэковый ад,
    * но они недостаточно вложенны,
    * поэтому я выделил им здесь место
    * */
    return optimiseStyles(
        optimiseScripts(
            newHtml,
            scriptContent
        ),
        styleContent,
        additionalClasses
    )
}
