const expressions = require("./expressions");
const {minimizeCSS} = require("./minimizators");

function generateVirtualCSS(styleContent, additionalSelectors = {}) {
    const minimizedCSS = minimizeCSS(styleContent)
    const virtualCSS = {}
    minimizedCSS.match(expressions.styleSelectors).forEach(selector => {
        const selectorName = `${selector.match(expressions.styleSelectorName)}`
            .replace(/\s*{/s, '')
        const selectorProperties = `${selector.match(expressions.styleSelectorProperties)}`
            .replace('{', '')
            .replace('}', '')
        const virtualProperties = {}
        selectorProperties.match(expressions.styleProperties).forEach(property => {
            let [propertyName, propertyValue] = property.split(expressions.stylePropertySplitter)
            propertyValue = propertyValue.replace(';', '')
            virtualProperties[propertyName] = propertyValue
        })
        if (virtualCSS[selectorName]) {
            virtualCSS[selectorName] = {...virtualCSS[selectorName], ...virtualProperties}
        } else {
            virtualCSS[selectorName] = virtualProperties
        }
    })
    return {...virtualCSS, ...additionalSelectors}
}

module.exports = {
    generateVirtualCSS
}